#include <stdio.h>

#define N  12

void ler_vetor(int v[]);
void zera(int h[][2]);
int conta_ocorr(int v[], int val);
int acha(int h[][2], int val, int n);
void prn_hist(int h[][2],int n);

main()
{
  int vet[N], hist[N][2], i, cont, n;

  printf("N=%d\n", N);
  ler_vetor(vet);
  zera(hist);

  cont = conta_ocorr(vet,0);
  n=0;
  if (cont)
    {
      hist[n][0] = 0;
      hist[n][1] = cont;
      n++;
    }

  /* para cada elemento de v[] */
  for (i = 0; i < N; i++)
    {
      if (!acha(hist, vet[i], n))
	{
	  hist[n][0] = vet[i];
	  hist[n][1] = conta_ocorr(vet, vet[i]);
	  n++;
	}
    }

  printf ("A sequencia tem %d valores distintos:", n);
  for (i = 0; i < N; i++) {
    if (hist[i][1])
      printf("%d", hist[i][0]);

    if (i < N-1)
      printf(", ");
    else
      printf(". Ocorrências:\n");

  }

  prn_hist(hist,n);

}


void ler_vetor(int v[])
{
  int i;

  printf("\tIndique %d elementos inteiros: ", N);
  for (i=0; i < N ; i++)
    {
      //      printf("\tElemento %d: ", i);
      scanf("%d", &v[i]);
    }
}

void zera(int h[][2])
{
  int i;

  for (i=0; i < N ; i++)
    h[i][0] = h[i][1] = 0;
}

int conta_ocorr(int v[], int val)
{
  int i, cont;

  for (i=cont=0; i < N; i++)
    {
      if (v[i] == val)
        {
	  cont++;
        }
    }

  return cont;
}

int acha(int h[][2], int val, int n)
{
  int i;

  for (i=0; i < n; i++)
    {
      if (h[i][0] == val)
	return 1;
    }

  return 0;
}



void prn_hist(int h[][2],int n)
{
  int i;

  for (i=0; i < n ; i++)
    printf("\t%d, %d vezes\n", h[i][0],h[i][1]);
}

